/**********************************************************************

	--- Qt Architect generated file ---

	File: SplitWin.cpp
	Last generated: Mon Sep 20 21:24:41 1999

 *********************************************************************/

#include "SplitWin.h"
#include <qfiledialog.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <stdlib.h>
#include <string.h>
#include <qtextstream.h>
#include <qapp.h>
#include <qprogressdialog.h>
#include <iostream.h>

#define Inherited SplitWinData

SplitWin::SplitWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "Split" );
	
	
	split_radiobutton->setChecked(TRUE);
	
	mbytes_radiobutton->setChecked(TRUE);
	
	size_lineedit->setText("1");
	
}

SplitWin::SplitWin
(
	char *file_name
)
	:
	Inherited( NULL, NULL )
{
	setCaption( "Split" );
	
	
	split_radiobutton->setChecked(TRUE);
	
	mbytes_radiobutton->setChecked(TRUE);
	
	size_lineedit->setText("1");
	
	filename_lineedit->setText(file_name);
	
	if(strstr(file_name,"000") != NULL) // assume join
	{
		join_radiobutton->setChecked(TRUE);
		joinClicked();
	}
	
	updateInfo();
	
}


SplitWin::~SplitWin()
{
}


void SplitWin::quitButton()
{

done(0);


}

void SplitWin::error(const char *text)
{
QMessageBox mb("Error",text,QMessageBox::Warning,
		QMessageBox::Ok,0,0,this);
		
		mb.exec();
}

void SplitWin::message(const char *text)
{
QMessageBox mb("Split",text,QMessageBox::NoIcon,
		QMessageBox::Ok,0,0,this);
		
		mb.exec();
}

int SplitWin::continueAbort(const char *text)
{
/*
	returns
		1 - ok pressed
		0 - abort pressed
*/
QMessageBox mb("Split",text,QMessageBox::NoIcon,
		QMessageBox::Ok|QMessageBox::Default,QMessageBox::Abort,0,this);
		
		switch(mb.exec())
		{
			case QMessageBox::Ok:
				return(1);
			break;
			default:
				return(0);
			break;
		}
}

void SplitWin::disableButtons()
{
	execute_button->setEnabled(FALSE);
	checksum_button->setEnabled(FALSE);
	quit_button->setEnabled(FALSE);
	inputbrowse_button->setEnabled(FALSE);
	outputdirbrowse_button->setEnabled(FALSE);
}

void SplitWin::enableButtons()
{
	execute_button->setEnabled(TRUE);
	checksum_button->setEnabled(TRUE);
	quit_button->setEnabled(TRUE);
	inputbrowse_button->setEnabled(TRUE);
	outputdirbrowse_button->setEnabled(TRUE);
}

const unsigned int max_size = 1000000;

void SplitWin::executeButton()
{

const char *QtSplitMagic="**** QtSplit ****";

	disableButtons();
				
	if(split_radiobutton->isChecked() == TRUE)
	{
		int check_sum;
		
		QString inputname = filename_lineedit->text();
		
		check_sum = checkSum(inputname);
		
		if(check_sum == -1)
		{
			enableButtons();
			return;
		}
	
		QFile infile(inputname);
		
		QFileInfo infileinfo(infile);
		
		inputname = infileinfo.fileName();
		
		if(infile.open(IO_ReadOnly) != TRUE)
		{
			error("Cannot open Input file");
			enableButtons();
			return;
		}
	
		unsigned int size;
		
		QString s_size(size_lineedit->text());
		
		size = s_size.toInt();
		
		if( kbytes_radiobutton->isChecked() == TRUE )
		{
			size = size *1024;
		}
		
		if( mbytes_radiobutton->isChecked() == TRUE )
		{
			size = size *1024*1024;
		}
		
		if(size == 0 )
		{
			error("bad size");
			infile.close();
			enableButtons();
			return;
		}
		
		unsigned int num_files;

		num_files =(int)( 1+((float)infile.size())/((float)size));

		unsigned int b_size;
		
		if(size < max_size)
		{
			b_size = size;
		}
		else
		{
			b_size = max_size;
		}
	
		QString outdir = outputdir_lineedit->text();
		
		QString outname;
		
		int fileno;
		
		fileno = 0;
		
		if(outdir.isEmpty() == FALSE)
		{
			outname.sprintf("%s/%s.%03i",(const char *)outdir,(const char *)inputname,fileno);	
		}
		else
		{
			outname.sprintf("%s.%03i",(const char *)inputname,fileno);	
		}		
	
		QFile outfile(outname);
		
		if(outfile.exists() == TRUE)
		{
			error("Output file exists");
			infile.close();
			enableButtons();
			return;
		}
		
		if(outfile.open(IO_WriteOnly) != TRUE)
		{
			QString msg;
			msg.sprintf("Cannot write to %s",(const char *)outname);
			error(msg);
			infile.close();
			enableButtons();
			return;
		}
		
		QTextStream os(&outfile);
		
		os<<QtSplitMagic<<"\n";
		os<<inputname<<"\n";
		os<<num_files<<"\n";
		os<<check_sum<<"\n";
		
		outfile.close();
		
		fileno++;
	
		if(outdir.isEmpty() == FALSE)
		{
			outname.sprintf("%s/%s.%03i",(const char *)outdir,(const char *)inputname,fileno);	
		}
		else
		{
			outname.sprintf("%s.%03i",(const char *)inputname,fileno);	
		}		

		outfile.setName(outname);
		
		if(outfile.exists() == TRUE)
		{
			error("Output file exists");
			infile.close();
			enableButtons();
			return;
		}
			
		if(outfile.open(IO_WriteOnly) != TRUE)
		{
			error("Cannot open output file");
			infile.close();
			enableButtons();
			return;
		}
		
		char *buff;
		
		buff = (char *) malloc(b_size);
		
		if( buff == NULL)
		{
			error("Can not allocate buffer");
			infile.close();
			outfile.close();
			outfile.remove();
			enableButtons();
			return;
		}
		
		
		unsigned int f_size;
		int r_actual,w_actual;
		
#ifdef INDV_CHECKSUM			
		unsigned short buff_sum;
		int file_sum;
#endif		
	 	setCursor( waitCursor );
		
		while(infile.atEnd() != TRUE )
		{
			f_size = 0;
			
			QString msg;
			
			msg.sprintf("Writing file %i",fileno);
			
   			QProgressDialog progress( msg, "Abort",
				 100, this,0,TRUE );
		
			progress.setMinimumDuration(0); // show progress immediately
       			progress.setProgress( 0 );
			
#ifdef INDV_CHECKSUM			
			buff_sum = 0;
#endif			
			while(f_size < size)
			{
				if((f_size + b_size) <= size)
				{
					r_actual=infile.readBlock(buff,b_size);
					if(r_actual == -1)
					{
						error("Read error");
						infile.close();
						outfile.close();
						free(buff);
						progress.cancel();
    						setCursor(arrowCursor);
						enableButtons();
						return;
					}
					
					if(r_actual == 0)
						break;

					w_actual=outfile.writeBlock(buff,r_actual);

					if(r_actual != w_actual)
					{
						error("Write error");
						infile.close();
						outfile.close();
						free(buff);
						progress.cancel();
    						setCursor(arrowCursor);
						enableButtons();
						return;
					}
						
					f_size += r_actual;
				}
				else
				{
					int t_size = size-f_size;
					r_actual=infile.readBlock(buff,t_size);
					if(r_actual == -1)
					{
						error("Read error");
						infile.close();
						outfile.close();
						free(buff);
						progress.cancel();
    						setCursor(arrowCursor);
						enableButtons();
						return;
					}
					
					if(r_actual == 0)
						break;

					w_actual=outfile.writeBlock(buff,r_actual);

					if(r_actual != w_actual)
					{
						error("Write error");
						infile.close();
						outfile.close();
						free(buff);
						progress.cancel();
    						setCursor(arrowCursor);
						enableButtons();
						return;
					}
						
					f_size += r_actual;
				}				
#ifdef INDV_CHECKSUM			
				buff_sum += bufferSum(buff,r_actual);
#endif									
        			if ( progress.wasCancelled() )
				{
            				infile.close();
					outfile.close();
					outfile.remove();
					free(buff);
    					setCursor(arrowCursor);
					enableButtons();
					return;
				}
				
       				progress.setProgress((f_size*100.)/size );
 				qApp->processEvents();				
			}			
			
       			progress.setProgress( 100 );
			
			outfile.close();
#ifdef INDV_CHECKSUM			
			file_sum = checkSum(outname);
			
			cout<<"file sum = "<<file_sum<<" buff sum = "<<buff_sum<<"\n";
			
			if(file_sum != buff_sum)
			{
				if(file_sum != -1)
					error("Check sum mismatch");
					
				infile.close();
				free(buff);
    				setCursor(arrowCursor);
				enableButtons();
				return;
			}
#endif			
			if(infile.atEnd() == TRUE)
				break;
			
			fileno++;
			
			if(pause_checkbox->isChecked() == TRUE)
			{
				qApp->beep();
				
				QString ans;
		
				ans.sprintf("Change media (%i)",fileno);
		
				if(continueAbort(ans) == 0)
				{
					infile.close();
					free(buff);
    					setCursor(arrowCursor);
					enableButtons();
					return;
				}
			}
			
			if(outdir.isEmpty() == FALSE)
			{
				outname.sprintf("%s/%s.%03i",(const char *)outdir,(const char *)inputname,fileno);	
			}
			else
			{
				outname.sprintf("%s.%03i",(const char *)inputname,fileno);	
			}
	
			outfile.setName(outname);
		
			if(outfile.exists() == TRUE)
			{
				error("Output file exists");
				infile.close();
				free(buff);
    				setCursor(arrowCursor);
				enableButtons();
				return;
			}
split_reopen:			
			if(outfile.open(IO_WriteOnly) != TRUE)
			{
				if(continueAbort("Cannot open output file, retry?") == 0)
				{
					infile.close();
					free(buff);
    					setCursor(arrowCursor);
					enableButtons();
					return;
				}
				else
				{
					goto split_reopen;
				}
			}
			
			
		}
		
		infile.close();
		
		free(buff);
		
		QString ans;
		
		ans.sprintf("Done, %i files written",fileno+1);
		
		message(ans);
		
    		setCursor(arrowCursor);
		
	}
	
	if(join_radiobutton->isChecked() == TRUE)
	{
	
		const int LINESZ=100;
		char line[LINESZ];
		
		QString msg;
		
		QString inputname = filename_lineedit->text();
		
		QFile infile(inputname);
		
		QFileInfo infileinfo(infile);
		
		if(infile.open(IO_ReadOnly) != TRUE)
		{
			msg = "Cannot open " + inputname;
			error(msg);
			enableButtons();
			return;
		}
		
		inputname = infileinfo.fileName();
		
		QString inputdir = infileinfo.dirPath(TRUE);
		
		QString basename(inputname);
		
		if( basename.contains(".000") == 0)
		{
			error("Input file must be number 000");
			enableButtons();
			return;
		}
		
		int loc;
		
		loc = basename.find(".000");
		
		basename.remove(loc,4);
		
		infile.readLine(line,LINESZ);
		line[strlen(line)-1] = '\0'; // strip \n
		
		if(strcmp(line,QtSplitMagic) != 0)
		{
			error("input file not from QtSplit");
			infile.close();
			enableButtons();
			return;
		}
		
		infile.readLine(line,LINESZ);
		line[strlen(line)-1] = '\0'; // strip \n
		
		if(strcmp(line,(const char *)basename) != 0)
		{
			error("filename mismatch");
			infile.close();
			enableButtons();
			return;
		}
		
		infile.readLine(line,LINESZ);
		line[strlen(line)-1] = '\0'; // strip \n
		
		int num_files = atoi(line);
		
		infile.readLine(line,LINESZ);
		line[strlen(line)-1] = '\0'; // strip \n
		
		int check_sum = atoi(line);
		
		msg.sprintf("Number of input files = %i, check sum = %i",num_files,check_sum);
	
		info_label->setText(msg);
				
		infile.close();
		
		QString outdir = outputdir_lineedit->text();
		
		QString outname;

		outname = outdir+"/"+basename;
		
		QFile outfile(outname);
		
		if(outfile.exists() == TRUE)
		{
			msg = outname + " exists";
			error(msg);
			enableButtons();
			return;
		}
		
		if(outfile.open(IO_WriteOnly) != TRUE)
		{
			msg="Cannot open " + outname;
			error(msg);
			enableButtons();
			return;
		}
		
		int file_no=1;
		
		char *buff;
		
	 	setCursor( waitCursor );
				
		while(file_no <= num_files)
		{
		
			inputname.sprintf("%s/%s.%03i",(const char *)inputdir,(const char *)basename,file_no);
				
			infile.setName(inputname);
read_retry:		
			if(infile.open(IO_ReadOnly) != TRUE)
			{
				msg = "Cannot open " + inputname+", retry?";
				if(continueAbort(msg) == 0)
				{
					outfile.close();
					outfile.remove();
    					setCursor(arrowCursor);
					enableButtons();
					return;
				}
				else
					goto read_retry;
			}
			
			unsigned int b_size;
		
			if(infile.size() < max_size)
			{
				b_size = infile.size();
			}
			else
			{
				b_size = max_size;
			}
			
			buff = (char *) malloc(b_size);
		
			if( buff == NULL)
			{
				error("can not allocate buffer");
				infile.close();
				outfile.close();
				outfile.remove();
    				setCursor(arrowCursor);
				enableButtons();
				return;
			}
			
			int r_actual,w_actual,f_size;
			
			msg.sprintf("Joining %s.%03i",(const char *)basename,file_no);
			
   			QProgressDialog progress( msg, "Abort", 
				100, this , 0, TRUE);
		
			progress.setMinimumDuration(0);
       			progress.setProgress( 0 );
			
			f_size = 0;
			
			while(infile.atEnd() != TRUE)
			{
			
				r_actual=infile.readBlock(buff,b_size);

				if(r_actual == -1)
				{
					error("read error");
					infile.close();
					outfile.close();
					outfile.remove();
					free(buff);
					progress.cancel();
					setCursor(arrowCursor);
					enableButtons();
					return;
				}
				
				w_actual = outfile.writeBlock(buff,r_actual);
				
				if(w_actual != r_actual)
				{
					error("write error");
					infile.close();
					outfile.close();
					outfile.remove();
					free(buff);
					progress.cancel();
    					setCursor(arrowCursor);
					enableButtons();
					return;
				}
				
        			if ( progress.wasCancelled() )
				{
            				infile.close();
					outfile.close();
					outfile.remove();
					free(buff);
					progress.cancel();
    					setCursor(arrowCursor);
					enableButtons();
					return;
				}
				
				
				f_size += r_actual;
							
       				progress.setProgress( (f_size*100.)/infile.size() );				
 				qApp->processEvents();	
			}
			
			infile.close();
			
			free(buff);
			
       			progress.setProgress( 100 );
			
			if( (pause_checkbox->isChecked() == TRUE) && (file_no != num_files) )
			{
				qApp->beep();
				
				msg.sprintf("Change media (%i)",file_no+1);
		
				if(continueAbort(msg) == 0)
				{
					outfile.close();
					outfile.remove();
    					setCursor(arrowCursor);
					enableButtons();
					return;
				}
			}
			
			file_no++;						
		}
		
		outfile.close();
		
    		setCursor(arrowCursor);
		
		int new_check_sum;
		
		new_check_sum = checkSum(outname);
		
		if(new_check_sum != -1)
		{		
			if(new_check_sum != check_sum)
			{
				error("Check sums do not match");
			}
			else
			{
				message("Join completed and verified");
			}
		}
		else
		{
			message("Join completed, but not verified");
		}
	
		qApp->beep();
		
	}
	
	enableButtons();
		
	
}

unsigned short SplitWin::bufferSum(char *buff,int count)
{
int i;
unsigned short sum;

	sum = 0;

	for(i=0;i<count;i++)
	{
		sum += buff[i];
	}
	
	return(sum);
}

int SplitWin::checkSum(const char *inputname)
{
/*
	check sum is an unsigned short, but returned in an int
	
	returns
	
		-1 -- error
		>=0 -- sum
*/

	QFile infile(inputname);
				
	if(infile.open(IO_ReadOnly) != TRUE)
	{
		error("Cannot open Input file");
		return(-1);
	}
	
	int file_size,num_blks;
	
	file_size=infile.size();
	
	num_blks = 1+file_size/max_size;
	
	char *buff;
	
	buff = (char *)malloc(max_size);
	
	int r_actual,blks;
	
	unsigned short sum;
	
	sum = 0;
	blks = 0;
		
	setCursor( waitCursor );
		
   	QProgressDialog progress( "Calculating Check Sum...", "Abort", 
				num_blks, this , 0, TRUE);
		
       	progress.setProgress( 0 );
	
	while(infile.atEnd() != TRUE)
	{
			
		r_actual = infile.readBlock(buff,max_size);
		
		if(r_actual == -1)
		{
			error("read error");
			infile.close();
			return(-1);
		}
		
		sum += bufferSum(buff,r_actual);
		
		blks++;
		progress.setProgress(blks);
		
        	if ( progress.wasCancelled() )
		{
            		infile.close();
			free(buff);
    			setCursor(arrowCursor);
			return(-1);
		}
				
 		qApp->processEvents();				
	}
	
	free(buff);
	
	infile.close();
	
	progress.setProgress(num_blks);
    	setCursor(arrowCursor);
	
	return(sum);


}

void SplitWin::checkSumButton()
{
	int sum;
	
	QString inputname = filename_lineedit->text();
		
	disableButtons();
	
	sum = checkSum(inputname);
	
	if(sum == -1)
	{
		enableButtons();
		return;
	}
	
	QString msg;
	
	msg.sprintf("Check Sum = %i",sum);
	
	message(msg);
	
	enableButtons();
}


void SplitWin::outputBrowseButton()
{

	QString filename=QFileDialog::getExistingDirectory (outputdir_lineedit->text(), this, NULL);
	
	outputdir_lineedit->setText(filename);

}
void SplitWin::inputBrowseButton()
{

	QString filename=QFileDialog::getOpenFileName ( filename_lineedit->text(),NULL, this, NULL);
	
	filename_lineedit->setText(filename);
	
	updateInfo();
	
}

void SplitWin::sizeChanged(const char *)
{
	updateInfo();
}

void SplitWin::updateInfo()
{
	if(split_radiobutton->isChecked() != TRUE)
		return;
		
	QString inputname = filename_lineedit->text();
	
	if(inputname.isEmpty() == TRUE || inputname.isNull() == TRUE)
		return;
		
	QFile infile(inputname);
	
	if(infile.exists() != TRUE)
		return;
		
	unsigned int size;
		
	QString s_size(size_lineedit->text());
	
	size = s_size.toInt();
		
	if(size == 0)
		return;
	
	if( kbytes_radiobutton->isChecked() == TRUE )
	{
		size = size *1024;
	}
		
	if( mbytes_radiobutton->isChecked() == TRUE )
	{
		size = size *1024*1024;
	}
	
	unsigned int f_size,num_files;

	f_size = infile.size();
	
	num_files =(int)( 1+((float)f_size)/((float)size));
	
	QString msg;
	
	msg.sprintf("Input File Size: %i    Number of output files = %i",f_size,num_files);
	
	info_label->setText(msg);
}

	
void SplitWin::splitClicked()
{

	file_label->setText("Input Filename");
	file_label->setEnabled(TRUE);
	
	filename_lineedit->setEnabled(TRUE);
	
	inputbrowse_button->setEnabled(TRUE);
	
	size_label->setEnabled(TRUE);
	
	size_lineedit->setEnabled(TRUE);
	
	bytes_radiobutton->setEnabled(TRUE);
	kbytes_radiobutton->setEnabled(TRUE);
	mbytes_radiobutton->setEnabled(TRUE);
	
	pause_checkbox->setEnabled(TRUE);
	
	info_label->setEnabled(TRUE);	


}
void SplitWin::joinClicked()
{
	file_label->setText("Input Filename");
	file_label->setEnabled(TRUE);
	
	filename_lineedit->setEnabled(TRUE);
	
	inputbrowse_button->setEnabled(TRUE);
	
	size_label->setEnabled(FALSE);
	
	size_lineedit->setEnabled(FALSE);
	
	bytes_radiobutton->setEnabled(FALSE);
	kbytes_radiobutton->setEnabled(FALSE);
	mbytes_radiobutton->setEnabled(FALSE);
	
	pause_checkbox->setEnabled(TRUE);
	
	info_label->setEnabled(TRUE);	
	

}
